/*!
 * Matcha - CSV Reporter
 * Copyright(c) 2013 Lauris Vavere <lauris@ma-1.lv>
 * MIT Licensed
 */

function pad (n) {
  return n < 10 ? '0' + n : n;
}

function toCsvDate (d) {
  return d.getFullYear() + '-' +
    pad(d.getMonth() + 1) + '-' +
    pad(d.getDate()) + ' ' +
    pad(d.getHours()) + ':' +
    pad(d.getMinutes()) + ':' +
    pad(d.getSeconds());
}

module.exports = function(runner, utils) {
  var curDate = toCsvDate(new Date());
  var curSuite = null;
  var curBench = null;

  runner.on('suite start', function (suite) {
    curSuite = suite.title;
  });

  runner.on('bench start', function (bench) {
    curBench = bench.title;
  });

  runner.on('bench end', function (results) {
    console.log(curDate + ',"' +
      curSuite + '","' +
      curBench + '",' +
      results.elapsed.toFixed(6) + "," +
      results.iterations
    );
  });
};
